import { MarkerSeries } from "./MarkerSeries";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { ScatterAxisInfoCache } from "./ScatterAxisInfoCache";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core";
import { NumericYAxis } from "./NumericYAxis";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CollisionAvoidanceType } from "./CollisionAvoidanceType";
import { Axis } from "./Axis";
import { ScatterItemSearchMode } from "./ScatterItemSearchMode";
import { ScatterErrorBarSettings } from "./ScatterErrorBarSettings";
import { HighlightingInfo } from "./HighlightingInfo";
import { ScatterFrame } from "./ScatterFrame";
import { SeriesView } from "./SeriesView";
import { Point, Type } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Rect } from "igniteui-react-core";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { SeriesHitTestMode } from "./SeriesHitTestMode";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { AxisRange } from "./AxisRange";
import { HashPool$2 } from "igniteui-react-core";
import { MarkerManagerBase } from "./MarkerManagerBase";
import { ScatterTrendLineManager } from "./ScatterTrendLineManager";
import { Thickness } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { AssigningScatterStyleEventArgs } from "./AssigningScatterStyleEventArgs";
import { AssigningScatterMarkerStyleEventArgs } from "./AssigningScatterMarkerStyleEventArgs";
import { AssigningSeriesStyleEventArgsBase } from "./AssigningSeriesStyleEventArgsBase";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { ErrorBarsHelper } from "./ErrorBarsHelper";
import { IErrorBarCalculator } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { RenderSurface } from "./RenderSurface";
import { IDictionary$2 } from "igniteui-react-core";
import { AssigningSeriesShapeStyleEventArgsBase } from "./AssigningSeriesShapeStyleEventArgsBase";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class ScatterBase extends MarkerSeries implements ISupportsErrorBars, ITrendLineSeries {
    static $t: Type;
    protected bp(): SeriesView;
    ji(): void;
    kk(a: SeriesView): void;
    p4: ScatterBaseView;
    protected get_dj(): boolean;
    ag(): Axis[];
    gt(a: any, b: string): any;
    ct(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    protected bj(): SeriesHitTestMode;
    n4(a: Point): Rect;
    dy(a: Point, b: boolean): boolean;
    constructor();
    p3: ScatterAxisInfoCache;
    xAxis: NumericXAxis;
    yAxis: NumericYAxis;
    rf: string;
    qi: IFastItemColumn$1<number>;
    private qg;
    rj: string;
    qj: IFastItemColumn$1<number>;
    private qh;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    sq: Brush;
    static readonly r7: DependencyProperty;
    trendLineThickness: number;
    ss: PenLineCap;
    sr: DoubleCollection;
    trendLinePeriod: number;
    pv: CollisionAvoidanceType;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    q4: number;
    q3: number;
    qe: ScatterItemSearchMode;
    q2: number;
    j2(): void;
    p5: ScatterErrorBarSettings;
    protected kp(a: any, b: string, c: any, d: any): void;
    protected qt(): boolean;
    protected qs(): boolean;
    qn(a: any): boolean;
    qm(a: any): boolean;
    private r6;
    private st;
    private su;
    private rl;
    protected qr(a: string, b: FastItemsSourceEventAction): boolean;
    protected jo(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    rx(a: ScatterFrame): void;
    ry(a: ScatterFrame, b: Clipper): void;
    ao(a: Axis): AxisRange;
    gq(a: Point): any;
    private qb;
    qc: ScatterItemSearchMode;
    protected qd(): ScatterItemSearchMode;
    f9(a: Point): number;
    e4(a: Point): number;
    protected qy(a: Point): number;
    private po;
    private pp;
    protected qx(a: Point): number;
    private ro;
    protected get_qq(): boolean;
    protected readonly qq: boolean;
    private q1;
    protected q0(a: Point): number;
    protected qz(a: Point): number;
    nt(a: Point, b: boolean, c: boolean): Point;
    dq(a: any): boolean;
    protected ln(a: Rect, b: Rect): void;
    protected lo(a: Rect, b: Rect): void;
    p8: ScatterFrame;
    qa: ScatterFrame;
    p7: ScatterFrame;
    rm(a: ScatterBaseView, b: ScatterFrame, c: number, d: Rect, e: Rect): void;
    ru(a: ScatterFrame, b: ScatterBaseView): void;
    jl(a: boolean, b: SeriesView): void;
    qp: boolean;
    qo: boolean;
    protected ql: boolean;
    protected qk: boolean;
    protected get_da(): boolean;
    private pz;
    private p0;
    protected px(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected py(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    n7(): Thickness;
    protected pw(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    au(a: any, b: Point, c: boolean): HighlightingInfo;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    protected qv(): boolean;
    protected qu(): boolean;
    r5(a: ScatterFrame, b: ScatterBaseView): void;
    pr(a: number, b: number): any[];
    protected ps(a: number, b: number): any[];
    protected qf: ScatterSeriesRenderManager;
    rn(a: ScatterBaseView, b: ScatterFrame): void;
    protected rq(a: number, b: number, c: boolean): void;
    protected rp(a: number, b: number, c: boolean): void;
    protected r0(a: AssigningScatterStyleEventArgs): void;
    protected rz(a: AssigningScatterMarkerStyleEventArgs): void;
    rs(a: ScatterFrame, b: ScatterBaseView): void;
    rv(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    rt(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: number, e: number, f: boolean): {
        p3?: number;
        p4?: number;
    };
    rr(a: OwnedPoint, b: ErrorBarsHelper, c: IErrorBarCalculator, d: any, e: number, f: number, g: boolean): {
        p4?: number;
        p5?: number;
    };
    rw(a: ErrorBarsHelper, b: IErrorBarCalculator, c: number, d: number, e: number, f: boolean): {
        p2?: number;
        p3?: number;
        p4?: number;
    };
    r2(a: ScatterFrame, b: ScatterBaseView): void;
    private r3;
    private r4;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    k4(a: boolean): void;
    protected lg(): void;
    p9: ScatterFrame;
    k5(a: Rect, b: RenderSurface): void;
    private p6;
    k2(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    r1(a: IDictionary$2<any, OwnedPoint>, b: HashPool$2<any, Marker>): void;
    pq(a: ScatterBaseView, b: HashPool$2<any, Marker>, c: Point[], d: Rect, e: Rect): Point[];
    qw(a: HashPool$2<any, Marker>, b: List$1<number>): List$1<number>;
    protected jv(a: any): void;
    fa(): number;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class ScatterSeriesRenderManager extends SeriesRenderManager {
    static $t: Type;
    protected c(): AssigningSeriesStyleEventArgsBase;
    protected a(): AssigningSeriesShapeStyleEventArgsBase;
    au: AssigningScatterMarkerStyleEventArgs;
    av: AssigningScatterStyleEventArgs;
    aw(a: ScatterBase, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ax(a: Series, b: boolean, c: (orderedStartIndex: number, orderedEndIndex: number) => any[]): void;
    ay(a: AssigningSeriesStyleEventArgsBase, b: number, c: number, d: boolean): void;
}
/**
 * @hidden
 */
export declare class ScatterBaseView extends MarkerSeriesView {
    static $t: Type;
    cv: MarkerManagerBase;
    protected ct: Point[];
    protected cw: ScatterBase;
    protected c1: List$1<number>;
    constructor(a: ScatterBase);
    private dc;
    private dd;
    cx: ScatterTrendLineManager;
    as(): void;
    private db;
    de(a: Marker): Size;
    protected cu(): MarkerManagerBase;
    protected c9(a: IDictionary$2<any, OwnedPoint>): void;
    c0(): List$1<Marker>;
    cs(): Point[];
    protected cr(): Point[];
    protected cz(): List$1<number>;
    c2(): void;
    c7(a: PathGeometry): void;
    c3(): void;
    c8(a: PathGeometry): void;
    da(): void;
    cy: HashPool$2<any, Marker>;
    cf(a: (arg1: Marker) => void): void;
    c5(a: (arg1: Marker) => void): void;
    c6(): void;
    protected a5(a: RenderingContext, b: boolean): void;
    c4(a: boolean): void;
    getDefaultTooltipTemplate(): string;
}
